# MatGeom
Matlab geometry toolbox for 2D/3D geometric computing

**MatGeom** is a library for geometric computing with Matlab in 2D and 3D. 
It contains several hundreds of functions for the creation and manipulation 
of 2D and 3D shapes such as point sets, lines, polygons, 3D meshes, ellipses... 

The official homepage for the project is http://github.com/mattools/matGeom. 
A starting help is provided in the [MatGeom wiki](https://github.com/mattools/matGeom/wiki "MatGeom Wiki homepage")

Package organization
---

The library is organized into several modules:

* [geom2d](https://github.com/mattools/matGeom/wiki/geom2d "geom2d Wiki page") - General functions in euclidean plane
* [polygons2d](https://github.com/mattools/matGeom/wiki/polygons2d "polygons2d Wiki page") - Functions operating on polygons and polylines represented as list of vertices
* [graphs](https://github.com/mattools/matGeom/wiki/graphs "graphs Wiki page") - Manipulation of geometric graphs
* [polynomialCurves2d](https://github.com/mattools/matGeom/wiki/polynomialCurves2d "polynomialCurves2d Wiki page") - Representation of smooth polynomial (Bezier) curves
* [geom3d](https://github.com/mattools/matGeom/wiki/geom3d "geom3d Wiki page") - General functions in 3D euclidean space
* [meshes3d](https://github.com/mattools/matGeom/wiki/meshes3d "meshes3d Wiki page") - Manipulation of 3D polygonal meshes (trimesh, quadmesh, or more generic meshes)
