function [v_top,f_top] = truncate_mesh(v,f,threshold)

if nargin < 3
    threshold = -71.75;
end
id_top = find((v(f(:,1),3)+v(f(:,2),3)+v(f(:,3),3))/3 >= threshold); 
[f_top, v_top, parent_top] = gpp_clean_mesh(f(id_top,:),v);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Additional procedure to avoid getting vertices with degree 2 (spikes) at the boundary
% Note: This part is optional. The input id_top and id_bottom can be kept
% unchanged by commenting out the entire for-loop below, 
% but the conformality of the resulting map may be affected.

% check vertices with degree 2
A_top = sparse([f_top(:,1);f_top(:,2);f_top(:,3);f_top(:,1);f_top(:,2);f_top(:,3)],[f_top(:,2);f_top(:,3);f_top(:,1);f_top(:,3);f_top(:,1);f_top(:,2)],ones(length(f_top)*6,1))/2;
A_top = ceil(A_top);
vid_degree_2_top = find(sum(A_top,2) == 2);
fid_degree_2_top_parent = zeros(size(vid_degree_2_top));
for i = 1:length(vid_degree_2_top)
    fid_degree_2_top = find(f_top(:,1) == vid_degree_2_top(i) | f_top(:,2) == vid_degree_2_top(i) | f_top(:,3) == vid_degree_2_top(i));
    fid_degree_2_top_parent(i) = find(f(:,1) == parent_top(f_top(fid_degree_2_top,1)) & f(:,2) == parent_top(f_top(fid_degree_2_top,2)) & f(:,3) == parent_top(f_top(fid_degree_2_top,3)));
end

% update id_top and id_bottom
id_top = setdiff(id_top, fid_degree_2_top_parent); 

[f_top, v_top, parent_top] = gpp_clean_mesh(f(id_top,:),v);